<template>
  <div class="executed-orders">
    <div class="account-filter">
      <div class="account-filter__close" :class="{active:isOpen}" @click="showPanel">
        <span v-if="!isOpen">Развернуть фильтр</span>
        <span>
        <span v-if="!isOpen" class="refresh" @click="getOrders()">Обновить</span>
        <i :class="['icon ', isOpen ? 'chevron-up' : 'chevron-down']"/>
      </span>

      </div>
      <div v-if="isOpen" class="account-filter__panel">
        <div class="row">
          <div class="col-xs-3 p-5">
            <ObSelect
                v-model="startAddress"
                label="Откуда"
                placeholder="Выберите"
                :remote-opt="api.contract.getLocations"
                :is-auto-complete="true"
                display-exp="russian_name"
                class="mb20"
                data-qa="locationFrom"
                valueExp="russian_name"
            />
          </div>
          <div class="col-xs-3 p-5">
            <ObSelect
                v-model="endAddress"
                label="Куда"
                placeholder="Выберите"
                :remote-opt="api.contract.getLocations"
                :is-auto-complete="true"
                display-exp="russian_name"
                class="mb20"
                data-qa="locationFrom"
                valueExp="russian_name"
            />
          </div>
          <div class="col-xs-2 p-5">
            <ob-date-picker
                label="Погрузка от"
                v-model="pvpDate"
                ref="after-date"
            />
          </div>
          <div class="col-xs-4 account-filter__refresh">
            <div class="account-filter__refresh-button">
              <span @click="getOrders()">Обновить</span>
            </div>
          </div>
        </div>
        <div class="row mt-20">
          <div class="col-xs-3 p-5">
            <ObSelect
                v-model="serviceUuid"
                :items="serviceOptions"
                label="Услуга"
                placeholder="Выберите"
            />
          </div>
          <div class="col-xs-5 p-5">
            <ObSelect
                v-model="resourceTypeUuid"
                :items="resourceTypeOptions"
                label="Тип ТС"
                placeholder="Выберите"
            />
          </div>
          <div class="col-xs-1 clear-filter" @click="clearFilters()">
            <span>Очистить</span>
            <i class="icon close"/>
          </div>
        </div>
      </div>
    </div>
    <div v-if="tableLoader" class="account-list-loader">
      <ob-loader
          :width="10"
          :height="10"
          :duration="2"
      />
    </div>
    <ob-table
        :page-limit="Infinity"
        :items="suborderList"
        :columns="columns"
        :tableHeight="tableHeight"
        :functional-panel="true"
        @select="selectedOrder"
        id="executed-orders-table"
        v-else
    >
      <template v-slot:extraFuncToPanel>
        <div class="account-tabs">
          <div
              v-for="(tab, index) in tabs"
              :key="index"
              :class="{'account-tabs__item-active': tab.id === activeTab }"
              class="account-tabs__item"
              @click="setActive(tab.id)"
          >
            <template>
              <span>{{tab.title}}</span>
            </template>
          </div>
        </div>
      </template>
      <div slot="route" slot-scope="{data}">
        <routeSlot :item="data.item"/>
      </div>
      <div slot="price" slot-scope="{data}">
        {{ (data.item.totalPrice / 100) | currency({ dot: 2 }) }} ₽
      </div>
      <div slot="vatPrice" slot-scope="{data}">
        {{ (data.item.vatPrice / 100) | currency({ dot: 2 }) }} ₽
      </div>
      <div slot="dateFromPvp" slot-scope="{data}">
        <dateFromSlot :item="data.item"/>
      </div>
      <div slot="dateForm" slot-scope="{data}">
        <dateFromSlot :item="data.item"/>
      </div>
      <div slot="status" slot-scope="{data}">
        <executedStatus :item="data.item"/>
      </div>
      <div slot="resourceNumber" slot-scope="{data}">
        <resourceNumber :item="data.item"/>
      </div>
      <div slot="advance" slot-scope="{data}">
        <span class="avans-icon" v-if="data.item.advanceStatus === 'IN_PROCESS'">
         <i class="icon advance-3"></i>
        </span>
        <span class="avans-icon" v-else-if="data.item.advanceStatus === 'NEW'">
          <i class="icon advance-2"></i>
        </span>
        <span class="avans-icon cancelled" v-else-if="data.item.advanceStatus === 'CANCELLED'">
         <i class="icon advance-0"></i>
        </span>
        <span class="avans-icon" v-else-if="data.item.advanceStatus === 'FULLY_PAID'">
         <i class="icon advance-4"></i>
        </span>
        <span v-else-if="data.item.advanceStatus === null">
          -
        </span>
        <span class="avans-icon" v-else>
           <i class="icon advance-1"></i>
        </span>
      </div>
    </ob-table>
  </div>
</template>

<script>
import ObTable from "common-components/src/obComponents/obTable";
import ObSelect from "common-components/src/obComponents/obSelect";
import ObDatePicker from "common-components/src/obComponents/obDatePickerConstructor";
import routeSlot from '../sections/list/slots/route';
import dateFromSlot from '../sections/list/slots/dateFrom';
import resourceNumber from '../sections/list/slots/resourceNumber';
import executedStatus from '../sections/list/slots/executedStatus';
import api from '@/api';
import ObLoader from "common-components/src/obComponents/obLoader";
import {mapGetters} from "vuex";
export default {
  name: "executedOrders",
  components:{
    ObTable,
    routeSlot,
    //priceSlot,
    ObSelect,
    ObDatePicker,
    dateFromSlot,
    executedStatus,
    resourceNumber,
    ObLoader
  },
  data() {
    return {
      serviceOptions: [],
      resourceTypeOptions: [],
      searchAddress: '',
      transport: "",
      transports: [],
      api,
      isOpen: true,
      resource: null,
      tableLoader: true,
      suborderList: [],
      tableHeight: 0,
      activeTab: 'ALL',
      tabs: [
        {
          id: 'ALL',
          title: 'Все'
        },
        {
          id: 'CANCELED',
          title: 'Отменён'
        }
        /*{
          id: 'ARCHIVAL',
          title: 'Архивный'
        }*/
      ],
      group: 'ARCHIVAL',
      subgroup: 'ALL',
      pvpDate: null,
      startAddress: null,
      endAddress: null,
      serviceUuid: null,
      resourceTypeUuid: null,
    }
  },
  computed: {
    ...mapGetters({
      orders: 'account/orders',
      order: 'account/order',
      VAT: 'account/vat'
    }),
    columns() {
      return [
        {
          title: '№ заказа',
          key: 'number',
          width: '100'
        },
        {
          title: 'дата создания',
          key: 'createdAt',
          slotName: 'dateForm'
        },
        {
          title: 'статус',
          key: 'status',
          slotName: 'status'
        },
        {
          title: 'Маршрут',
          key: 'startAddress',
          slotName: 'route',
        },
        {
          title: 'тягач',
          key: 'resourceNumber',
          slotName: 'resourceNumber'},
        {
          title: 'Водитель',
          key: 'fio'
        },
        {
          title: 'план: погрузка',
          key: 'pvpDate',
          slotName: 'dateFromPvp'
        },
        {
          title: 'Авансирование',
          key: 'advance',
          slotName: 'advance'
        },
        {
          title: 'сумма итого',
          key: 'totalPrice',
          slotName: 'price',
          width: '120'
        },
        {
          title: 'в том числе НДС',
          key: 'vatValue',
          slotName: 'vatPrice',
          width: '120'
        }
      ]
    },
    getFilters(){
      let dopParams = ''
      dopParams += this.subgroup != null ? `&subgroup=${this.activeTab}`  : ''
      dopParams += this.pvpDate != null ? `&pvpDate=${this.pvpDate}`  : ''
      dopParams += this.startAddress != null ? `&startAddress=${this.startAddress}`  : ''
      dopParams += this.endAddress != null ? `&endAddress=${this.endAddress}`  : ''
      dopParams += this.serviceUuid != null ? `&serviceUuid=${this.serviceUuid}`  : ''
      dopParams += this.resourceTypeUuid != null ? `&resourceTypeUuid=${this.resourceTypeUuid}`  : ''

      return `?group=${this.group}` + dopParams
    }
  },
  watch: {
    'serviceUuid'() {
      this.typeTransport();
    }
  },
  methods: {
    setActive(tabId){
      this.activeTab = tabId
      this.getOrders();
    },
    transformArray(array, uuid, title) {
      return array.map((key) => {
        return {
          uuid: key[uuid],
          title: key[title]
        }
      })
    },
    // проверка на одинаковые объекты
    filterByProperty(array, propertyName) {
      let occurrences = {}
      return array.filter(function(x) {
        let property = x[propertyName]
        if (occurrences[property]) {
          return false;
        }
        occurrences[property] = true;
        return true;
      })
    },
    getOrders(){
      this.tableLoader = true
      api.accountOrder.getAccountOrdersTwo(this.getFilters).then(res => {
        res.data.content = res.data.content.map((item) => {
          return {
            ...item,
            vatPrice: item.orderTotalAmount?.vatPrice || item.vatPrice,
            totalPrice: item.orderTotalAmount?.priceWithVat || item.totalPrice
          }
        })

        this.suborderList = res.data.content

        //заполнение селектов в фильтрации (услуга, тип ТС)
        this.serviceOptions =
            Object.keys(this.suborderList).length ?
                this.filterByProperty(this.transformArray(this.suborderList, 'serviceUuid', 'serviceTitle'), 'title') : [];
        this.resourceTypeOptions =
            Object.keys(this.suborderList).length ?
                this.filterByProperty(this.transformArray(this.suborderList, 'resourceTypeUuid', 'resourceTypeTitle'), 'title') : [];
        // END

        this.tableLoader = false
      })
    },
    selectedOrder(order) {
      this.$router.push({path: '/order-item/' + order.uuid, query: {is_suborder: 'true'}});
    },
    showPanel() {
      this.isOpen = !this.isOpen;
      this.$emit('changeHeight')
    },
    clearFilters(){
      this.pvpDate = null
      this.startAddress = null
      this.endAddress = null
      this.serviceUuid = null
      this.resourceTypeUuid = null
      this. getOrders();
    },
    async meansTransport() {
      return await api.dictionaries.resources.getResourceSpeciesByClass('e7519b46-faf4-11e9-8f0b-362b9e155667')
    },
    async typeTransport() {
      if (this.serviceUuid !== null) {
        this.transports = await api.dictionaries.resources.getOrderResourcesTypesBySpecies(this.serviceUuid);
      }
    },
  },
  mounted() {
    /**
     * 430px образуется за счет того, что
     * => 276px - это отсуп с самого вверха страницы и до низа хедера таблицы
     * => 124px - высота панели фильтров
     * => и 30px - отступ снизу между гницей снизу таблицы и до конца страницы
     **/
    this.tableHeight = window.innerHeight - 430;
    this.getOrders();
  }
}
</script>

<style scoped lang="scss">
.account-filter {
  position: relative;
  padding: 16px;
  border-bottom: 1px solid $lavender;

  &__refresh {
    display: flex;
    height: 52px;
    align-items: center;
    line-height: 20px;
    letter-spacing: 0.4px;
    color: $color-blue-navy-blue;

    &-button, &-close {
      cursor: pointer;
    }

    &-button {
      display: inherit;

      span {
        margin-left: 10px;
      }
    }
  }

  &__panel {
    margin-top: 10px;
    .row {
      margin: 5px 0;
      &.mt-20{
        margin-top: 20px;
      }
      .p-5{
        padding-right: 5px;
        padding-left: 5px;
      }
    }
    .radio-buttons {
      &__label{
        font-size: 12px;
        line-height: 12px;
        letter-spacing: 0.4px;
        color: $color-grey-span;
        margin-bottom: 10px;
      }
      &__line {
        display: flex;
        .ml17{
          margin-left: 17px;
        }
      }
    }
    .clear-filter{
      display: flex;
      align-items: center;
      cursor: pointer;
      span{
        color: $color-grey-span;
        font-size: 12px;
        line-height: 20px;
        margin-left: 10px;
      }
      .icon{
        color: $color-grey-border;
        font-size: 16px;
        line-height: 20px;
        margin-left: 8px;
      }
    }
  }

  &__close {
    display: flex;
    justify-content: space-between;
    align-items: center;
    width: 100%;
    cursor: pointer;
    color: $color-blue-navy-blue;
    font-size: 12px;
    z-index: 1;
    .refresh{
      font-size: 12px;
      margin-right: 21px;
      position: relative;
      top: -3px;
    }
    &.active{
      justify-content: flex-end;
      position: absolute;
      width: 50px;
      top: 16px;
      right: 16px;
    }
    i{
      font-size: 20px;
    }
  }
}
.executed-orders{
  margin: 20px 20px 0;
  background: #fff;
  width: 100%;
}
.account-tabs {
  display: flex;
  width: 100%;
  &__item {
    display: flex;
    justify-content: center;
    align-self: center;
    height: 30px;
    font-size: 14px;
    line-height: 16px;
    color: $color-blue-navy-blue;
    padding: 7px 12px;
    border: 1px solid $color-grey-border;
    box-sizing: border-box;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
    cursor: pointer;
    span{
      margin-left: 0;
    }
    &:first-child{
      border-radius: 3px 0 0 3px;
    }
    &:nth-child(5){
      border-radius: 0 3px 3px 0;
    }
    &:last-child{
      border-radius: 3px;
      margin-left: 10px;
    }
    &-active {
      border: none;
      background: $blue-blue-hoarfrost;
      box-shadow: inset 0 4px 4px rgba(0, 75, 200, 0.3);
    }
    &-disabled {
      cursor: default;
      color: #A3A5AD;
      background: $color-white-lilac;
      pointer-events: none;
    }
    &-caution {
      position: relative;
      &:after {
        content: '';
        position: absolute;
        width: 6px;
        height: 6px;
        background: #10CF96;
        border-radius: 50%;
        margin-left: 2px;
      }
    }
    & > i.clock {
      font-size: 16px;
      font-weight: bold;
      &::before {
        color: $color-error;
      }
    }
  }
}
::v-deep table{
  min-width: auto;
  border-collapse:inherit;
  td{
    &:nth-child(8){
      div{
        margin: 0 auto;
        text-align: center;
      }
    }
    &:nth-child(9) ,&:nth-child(10){
      div{
        width: 100%;
        text-align: right;
      }
    }
  }
}
::v-deep .ob-func-panel{
  &__controls{
    justify-content: flex-start;
    &-side{
      &:first-child{
        .ob-func-panel__control{
          &:nth-child(1){
            display: none;
          }
          &:nth-child(2){
            display: none;
          }
          &:nth-child(4){
            display: none;
          }
        }
      }
      &:last-child{
        width: 100%;
        .ob-func-panel__control{
          &:first-child{
            width: 100%;
          }
        }
      }
    }
  }
}
::v-deep .ob-table-inner{
  height: auto;
}
::v-deep .table-panel-inner{
  &::-webkit-scrollbar {
    width: 6px;
    background: transparent;
    opacity: .3;
  }
  &::-webkit-scrollbar-thumb {
    background: #b3d4e4;
    border-radius: 3px;
  }
  &::-webkit-scrollbar-track {
    background: transparent;
  }
}
.avans-icon{
  .icon{
    font-size: 16px;
    color: $Green-700;
  }
  &.cancelled{
    .icon{
      color: $color-error;
    }
  }
}

</style>
